# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from procman_ros/ProcmanCmdDesired.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import procman_ros.msg

class ProcmanCmdDesired(genpy.Message):
  _md5sum = "a98097fe6833fcdfa9ca49dc05bbdb9b"
  _type = "procman_ros/ProcmanCmdDesired"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# describes the state of a command managed by the procman sheriff/deputy
# ============ set by the sheriff ==========

# describes the command
ProcmanCmd cmd

# to start a command running, the sheriff should change desired_runid and
# unset force_quit
int32 desired_runid

# flag set by the sheriff.  If set, then the deputy should forcefully
# terminate the command
bool force_quit


================================================================================
MSG: procman_ros/ProcmanCmd
# Uniquely identifies the command
string command_id

# Executable string.
string exec_str

# Logical group that the command belongs to.
string group

# If true and the command stops running on its own, then the deputy will
# automatically restart the command.
bool auto_respawn

# The POSIX signal number to send when stopping the command. Typically
# this is something like SIGINT or SIGTERM
int8 stop_signal

# How much time (seconds) to allow the command to gracefully terminate,
# when stopping the command, before issuing a SIGKILL.
float32 stop_time_allowed

"""
  __slots__ = ['cmd','desired_runid','force_quit']
  _slot_types = ['procman_ros/ProcmanCmd','int32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cmd,desired_runid,force_quit

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ProcmanCmdDesired, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      if self.desired_runid is None:
        self.desired_runid = 0
      if self.force_quit is None:
        self.force_quit = False
    else:
      self.cmd = procman_ros.msg.ProcmanCmd()
      self.desired_runid = 0
      self.force_quit = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.cmd.command_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.exec_str
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BbfiB().pack(_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.desired_runid, _x.force_quit))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.command_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.command_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.exec_str = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.exec_str = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.group = str[start:end]
      _x = self
      start = end
      end += 11
      (_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.desired_runid, _x.force_quit,) = _get_struct_BbfiB().unpack(str[start:end])
      self.cmd.auto_respawn = bool(self.cmd.auto_respawn)
      self.force_quit = bool(self.force_quit)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.cmd.command_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.exec_str
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BbfiB().pack(_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.desired_runid, _x.force_quit))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.command_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.command_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.exec_str = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.exec_str = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.group = str[start:end]
      _x = self
      start = end
      end += 11
      (_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.desired_runid, _x.force_quit,) = _get_struct_BbfiB().unpack(str[start:end])
      self.cmd.auto_respawn = bool(self.cmd.auto_respawn)
      self.force_quit = bool(self.force_quit)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BbfiB = None
def _get_struct_BbfiB():
    global _struct_BbfiB
    if _struct_BbfiB is None:
        _struct_BbfiB = struct.Struct("<BbfiB")
    return _struct_BbfiB
