# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from procman_ros/ProcmanCmdStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import procman_ros.msg

class ProcmanCmdStatus(genpy.Message):
  _md5sum = "7123dda07ea4fb4e8a54979d8304878d"
  _type = "procman_ros/ProcmanCmdStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# describes the state of a command managed by the procman sheriff/deputy

# The command to execute.
ProcmanCmd cmd

# If the command is running, then this is the pid if not, then this is
# zero.
int32 pid

# an ID for the run instance
int32 actual_runid

# the last exit code
int32 exit_code

# [0, 1]
float32 cpu_usage

# total virtual memory used by the process
int64 mem_vsize_bytes

# total physical memory used by the process
int64 mem_rss_bytes


================================================================================
MSG: procman_ros/ProcmanCmd
# Uniquely identifies the command
string command_id

# Executable string.
string exec_str

# Logical group that the command belongs to.
string group

# If true and the command stops running on its own, then the deputy will
# automatically restart the command.
bool auto_respawn

# The POSIX signal number to send when stopping the command. Typically
# this is something like SIGINT or SIGTERM
int8 stop_signal

# How much time (seconds) to allow the command to gracefully terminate,
# when stopping the command, before issuing a SIGKILL.
float32 stop_time_allowed

"""
  __slots__ = ['cmd','pid','actual_runid','exit_code','cpu_usage','mem_vsize_bytes','mem_rss_bytes']
  _slot_types = ['procman_ros/ProcmanCmd','int32','int32','int32','float32','int64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cmd,pid,actual_runid,exit_code,cpu_usage,mem_vsize_bytes,mem_rss_bytes

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ProcmanCmdStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      if self.pid is None:
        self.pid = 0
      if self.actual_runid is None:
        self.actual_runid = 0
      if self.exit_code is None:
        self.exit_code = 0
      if self.cpu_usage is None:
        self.cpu_usage = 0.
      if self.mem_vsize_bytes is None:
        self.mem_vsize_bytes = 0
      if self.mem_rss_bytes is None:
        self.mem_rss_bytes = 0
    else:
      self.cmd = procman_ros.msg.ProcmanCmd()
      self.pid = 0
      self.actual_runid = 0
      self.exit_code = 0
      self.cpu_usage = 0.
      self.mem_vsize_bytes = 0
      self.mem_rss_bytes = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.cmd.command_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.exec_str
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Bbf3if2q().pack(_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.command_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.command_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.exec_str = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.exec_str = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.group = str[start:end]
      _x = self
      start = end
      end += 38
      (_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes,) = _get_struct_Bbf3if2q().unpack(str[start:end])
      self.cmd.auto_respawn = bool(self.cmd.auto_respawn)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.cmd.command_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.exec_str
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.cmd.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Bbf3if2q().pack(_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cmd is None:
        self.cmd = procman_ros.msg.ProcmanCmd()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.command_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.command_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.exec_str = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.exec_str = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.cmd.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.cmd.group = str[start:end]
      _x = self
      start = end
      end += 38
      (_x.cmd.auto_respawn, _x.cmd.stop_signal, _x.cmd.stop_time_allowed, _x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes,) = _get_struct_Bbf3if2q().unpack(str[start:end])
      self.cmd.auto_respawn = bool(self.cmd.auto_respawn)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Bbf3if2q = None
def _get_struct_Bbf3if2q():
    global _struct_Bbf3if2q
    if _struct_Bbf3if2q is None:
        _struct_Bbf3if2q = struct.Struct("<Bbf3if2q")
    return _struct_Bbf3if2q
