# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from procman_ros/ProcmanDeputyInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import procman_ros.msg

class ProcmanDeputyInfo(genpy.Message):
  _md5sum = "47b244537230e13c453ee3047cdfe314"
  _type = "procman_ros/ProcmanDeputyInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# message sent by a procman deputy, primarily intended for the procman
# sheriff.  informs the sheriff of the status of processes running on the
# host managed by the deputy.

time timestamp
string deputy_id

# [0, 1]
float32 cpu_load

int64 phys_mem_total_bytes
int64 phys_mem_free_bytes
int64 swap_total_bytes
int64 swap_free_bytes

int32 ncmds
ProcmanCmdStatus[] cmds


================================================================================
MSG: procman_ros/ProcmanCmdStatus
# describes the state of a command managed by the procman sheriff/deputy

# The command to execute.
ProcmanCmd cmd

# If the command is running, then this is the pid if not, then this is
# zero.
int32 pid

# an ID for the run instance
int32 actual_runid

# the last exit code
int32 exit_code

# [0, 1]
float32 cpu_usage

# total virtual memory used by the process
int64 mem_vsize_bytes

# total physical memory used by the process
int64 mem_rss_bytes


================================================================================
MSG: procman_ros/ProcmanCmd
# Uniquely identifies the command
string command_id

# Executable string.
string exec_str

# Logical group that the command belongs to.
string group

# If true and the command stops running on its own, then the deputy will
# automatically restart the command.
bool auto_respawn

# The POSIX signal number to send when stopping the command. Typically
# this is something like SIGINT or SIGTERM
int8 stop_signal

# How much time (seconds) to allow the command to gracefully terminate,
# when stopping the command, before issuing a SIGKILL.
float32 stop_time_allowed

"""
  __slots__ = ['timestamp','deputy_id','cpu_load','phys_mem_total_bytes','phys_mem_free_bytes','swap_total_bytes','swap_free_bytes','ncmds','cmds']
  _slot_types = ['time','string','float32','int64','int64','int64','int64','int32','procman_ros/ProcmanCmdStatus[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,deputy_id,cpu_load,phys_mem_total_bytes,phys_mem_free_bytes,swap_total_bytes,swap_free_bytes,ncmds,cmds

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ProcmanDeputyInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.deputy_id is None:
        self.deputy_id = ''
      if self.cpu_load is None:
        self.cpu_load = 0.
      if self.phys_mem_total_bytes is None:
        self.phys_mem_total_bytes = 0
      if self.phys_mem_free_bytes is None:
        self.phys_mem_free_bytes = 0
      if self.swap_total_bytes is None:
        self.swap_total_bytes = 0
      if self.swap_free_bytes is None:
        self.swap_free_bytes = 0
      if self.ncmds is None:
        self.ncmds = 0
      if self.cmds is None:
        self.cmds = []
    else:
      self.timestamp = genpy.Time()
      self.deputy_id = ''
      self.cpu_load = 0.
      self.phys_mem_total_bytes = 0
      self.phys_mem_free_bytes = 0
      self.swap_total_bytes = 0
      self.swap_free_bytes = 0
      self.ncmds = 0
      self.cmds = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.deputy_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f4qi().pack(_x.cpu_load, _x.phys_mem_total_bytes, _x.phys_mem_free_bytes, _x.swap_total_bytes, _x.swap_free_bytes, _x.ncmds))
      length = len(self.cmds)
      buff.write(_struct_I.pack(length))
      for val1 in self.cmds:
        _v1 = val1.cmd
        _x = _v1.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.exec_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1
        buff.write(_get_struct_Bbf().pack(_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed))
        _x = val1
        buff.write(_get_struct_3if2q().pack(_x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.cmds is None:
        self.cmds = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.deputy_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.deputy_id = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.cpu_load, _x.phys_mem_total_bytes, _x.phys_mem_free_bytes, _x.swap_total_bytes, _x.swap_free_bytes, _x.ncmds,) = _get_struct_f4qi().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cmds = []
      for i in range(0, length):
        val1 = procman_ros.msg.ProcmanCmdStatus()
        _v2 = val1.cmd
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.command_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.exec_str = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.exec_str = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.group = str[start:end]
        _x = _v2
        start = end
        end += 6
        (_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed,) = _get_struct_Bbf().unpack(str[start:end])
        _v2.auto_respawn = bool(_v2.auto_respawn)
        _x = val1
        start = end
        end += 32
        (_x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes,) = _get_struct_3if2q().unpack(str[start:end])
        self.cmds.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.deputy_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f4qi().pack(_x.cpu_load, _x.phys_mem_total_bytes, _x.phys_mem_free_bytes, _x.swap_total_bytes, _x.swap_free_bytes, _x.ncmds))
      length = len(self.cmds)
      buff.write(_struct_I.pack(length))
      for val1 in self.cmds:
        _v3 = val1.cmd
        _x = _v3.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.exec_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3
        buff.write(_get_struct_Bbf().pack(_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed))
        _x = val1
        buff.write(_get_struct_3if2q().pack(_x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.cmds is None:
        self.cmds = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.deputy_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.deputy_id = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.cpu_load, _x.phys_mem_total_bytes, _x.phys_mem_free_bytes, _x.swap_total_bytes, _x.swap_free_bytes, _x.ncmds,) = _get_struct_f4qi().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cmds = []
      for i in range(0, length):
        val1 = procman_ros.msg.ProcmanCmdStatus()
        _v4 = val1.cmd
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.command_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.exec_str = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.exec_str = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.group = str[start:end]
        _x = _v4
        start = end
        end += 6
        (_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed,) = _get_struct_Bbf().unpack(str[start:end])
        _v4.auto_respawn = bool(_v4.auto_respawn)
        _x = val1
        start = end
        end += 32
        (_x.pid, _x.actual_runid, _x.exit_code, _x.cpu_usage, _x.mem_vsize_bytes, _x.mem_rss_bytes,) = _get_struct_3if2q().unpack(str[start:end])
        self.cmds.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3if2q = None
def _get_struct_3if2q():
    global _struct_3if2q
    if _struct_3if2q is None:
        _struct_3if2q = struct.Struct("<3if2q")
    return _struct_3if2q
_struct_Bbf = None
def _get_struct_Bbf():
    global _struct_Bbf
    if _struct_Bbf is None:
        _struct_Bbf = struct.Struct("<Bbf")
    return _struct_Bbf
_struct_f4qi = None
def _get_struct_f4qi():
    global _struct_f4qi
    if _struct_f4qi is None:
        _struct_f4qi = struct.Struct("<f4qi")
    return _struct_f4qi
