# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from procman_ros/ProcmanOrders.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import procman_ros.msg

class ProcmanOrders(genpy.Message):
  _md5sum = "6540d7c0d68115e54f40b880f9ca7efa"
  _type = "procman_ros/ProcmanOrders"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# message sent by the procman sheriff to provide instructions for a procman
# deputy.

time timestamp
string deputy_id
string sheriff_id

int32 ncmds
ProcmanCmdDesired[] cmds


================================================================================
MSG: procman_ros/ProcmanCmdDesired
# describes the state of a command managed by the procman sheriff/deputy
# ============ set by the sheriff ==========

# describes the command
ProcmanCmd cmd

# to start a command running, the sheriff should change desired_runid and
# unset force_quit
int32 desired_runid

# flag set by the sheriff.  If set, then the deputy should forcefully
# terminate the command
bool force_quit


================================================================================
MSG: procman_ros/ProcmanCmd
# Uniquely identifies the command
string command_id

# Executable string.
string exec_str

# Logical group that the command belongs to.
string group

# If true and the command stops running on its own, then the deputy will
# automatically restart the command.
bool auto_respawn

# The POSIX signal number to send when stopping the command. Typically
# this is something like SIGINT or SIGTERM
int8 stop_signal

# How much time (seconds) to allow the command to gracefully terminate,
# when stopping the command, before issuing a SIGKILL.
float32 stop_time_allowed

"""
  __slots__ = ['timestamp','deputy_id','sheriff_id','ncmds','cmds']
  _slot_types = ['time','string','string','int32','procman_ros/ProcmanCmdDesired[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,deputy_id,sheriff_id,ncmds,cmds

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ProcmanOrders, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.deputy_id is None:
        self.deputy_id = ''
      if self.sheriff_id is None:
        self.sheriff_id = ''
      if self.ncmds is None:
        self.ncmds = 0
      if self.cmds is None:
        self.cmds = []
    else:
      self.timestamp = genpy.Time()
      self.deputy_id = ''
      self.sheriff_id = ''
      self.ncmds = 0
      self.cmds = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.deputy_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sheriff_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.ncmds
      buff.write(_get_struct_i().pack(_x))
      length = len(self.cmds)
      buff.write(_struct_I.pack(length))
      for val1 in self.cmds:
        _v1 = val1.cmd
        _x = _v1.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.exec_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1
        buff.write(_get_struct_Bbf().pack(_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed))
        _x = val1
        buff.write(_get_struct_iB().pack(_x.desired_runid, _x.force_quit))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.cmds is None:
        self.cmds = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.deputy_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.deputy_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sheriff_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sheriff_id = str[start:end]
      start = end
      end += 4
      (self.ncmds,) = _get_struct_i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cmds = []
      for i in range(0, length):
        val1 = procman_ros.msg.ProcmanCmdDesired()
        _v2 = val1.cmd
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.command_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.exec_str = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.exec_str = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v2.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v2.group = str[start:end]
        _x = _v2
        start = end
        end += 6
        (_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed,) = _get_struct_Bbf().unpack(str[start:end])
        _v2.auto_respawn = bool(_v2.auto_respawn)
        _x = val1
        start = end
        end += 5
        (_x.desired_runid, _x.force_quit,) = _get_struct_iB().unpack(str[start:end])
        val1.force_quit = bool(val1.force_quit)
        self.cmds.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.deputy_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sheriff_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.ncmds
      buff.write(_get_struct_i().pack(_x))
      length = len(self.cmds)
      buff.write(_struct_I.pack(length))
      for val1 in self.cmds:
        _v3 = val1.cmd
        _x = _v3.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.exec_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3
        buff.write(_get_struct_Bbf().pack(_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed))
        _x = val1
        buff.write(_get_struct_iB().pack(_x.desired_runid, _x.force_quit))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.cmds is None:
        self.cmds = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.deputy_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.deputy_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sheriff_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sheriff_id = str[start:end]
      start = end
      end += 4
      (self.ncmds,) = _get_struct_i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cmds = []
      for i in range(0, length):
        val1 = procman_ros.msg.ProcmanCmdDesired()
        _v4 = val1.cmd
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.command_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.exec_str = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.exec_str = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.group = str[start:end]
        _x = _v4
        start = end
        end += 6
        (_x.auto_respawn, _x.stop_signal, _x.stop_time_allowed,) = _get_struct_Bbf().unpack(str[start:end])
        _v4.auto_respawn = bool(_v4.auto_respawn)
        _x = val1
        start = end
        end += 5
        (_x.desired_runid, _x.force_quit,) = _get_struct_iB().unpack(str[start:end])
        val1.force_quit = bool(val1.force_quit)
        self.cmds.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_Bbf = None
def _get_struct_Bbf():
    global _struct_Bbf
    if _struct_Bbf is None:
        _struct_Bbf = struct.Struct("<Bbf")
    return _struct_Bbf
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
_struct_iB = None
def _get_struct_iB():
    global _struct_iB
    if _struct_iB is None:
        _struct_iB = struct.Struct("<iB")
    return _struct_iB
