// Auto-generated. Do not edit!

// (in-package procman_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ProcmanCmd = require('./ProcmanCmd.js');

//-----------------------------------------------------------

class ProcmanCmdDesired {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.cmd = null;
      this.desired_runid = null;
      this.force_quit = null;
    }
    else {
      if (initObj.hasOwnProperty('cmd')) {
        this.cmd = initObj.cmd
      }
      else {
        this.cmd = new ProcmanCmd();
      }
      if (initObj.hasOwnProperty('desired_runid')) {
        this.desired_runid = initObj.desired_runid
      }
      else {
        this.desired_runid = 0;
      }
      if (initObj.hasOwnProperty('force_quit')) {
        this.force_quit = initObj.force_quit
      }
      else {
        this.force_quit = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcmanCmdDesired
    // Serialize message field [cmd]
    bufferOffset = ProcmanCmd.serialize(obj.cmd, buffer, bufferOffset);
    // Serialize message field [desired_runid]
    bufferOffset = _serializer.int32(obj.desired_runid, buffer, bufferOffset);
    // Serialize message field [force_quit]
    bufferOffset = _serializer.bool(obj.force_quit, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcmanCmdDesired
    let len;
    let data = new ProcmanCmdDesired(null);
    // Deserialize message field [cmd]
    data.cmd = ProcmanCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [desired_runid]
    data.desired_runid = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [force_quit]
    data.force_quit = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ProcmanCmd.getMessageSize(object.cmd);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a message object
    return 'procman_ros/ProcmanCmdDesired';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a98097fe6833fcdfa9ca49dc05bbdb9b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # describes the state of a command managed by the procman sheriff/deputy
    # ============ set by the sheriff ==========
    
    # describes the command
    ProcmanCmd cmd
    
    # to start a command running, the sheriff should change desired_runid and
    # unset force_quit
    int32 desired_runid
    
    # flag set by the sheriff.  If set, then the deputy should forcefully
    # terminate the command
    bool force_quit
    
    
    ================================================================================
    MSG: procman_ros/ProcmanCmd
    # Uniquely identifies the command
    string command_id
    
    # Executable string.
    string exec_str
    
    # Logical group that the command belongs to.
    string group
    
    # If true and the command stops running on its own, then the deputy will
    # automatically restart the command.
    bool auto_respawn
    
    # The POSIX signal number to send when stopping the command. Typically
    # this is something like SIGINT or SIGTERM
    int8 stop_signal
    
    # How much time (seconds) to allow the command to gracefully terminate,
    # when stopping the command, before issuing a SIGKILL.
    float32 stop_time_allowed
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcmanCmdDesired(null);
    if (msg.cmd !== undefined) {
      resolved.cmd = ProcmanCmd.Resolve(msg.cmd)
    }
    else {
      resolved.cmd = new ProcmanCmd()
    }

    if (msg.desired_runid !== undefined) {
      resolved.desired_runid = msg.desired_runid;
    }
    else {
      resolved.desired_runid = 0
    }

    if (msg.force_quit !== undefined) {
      resolved.force_quit = msg.force_quit;
    }
    else {
      resolved.force_quit = false
    }

    return resolved;
    }
};

module.exports = ProcmanCmdDesired;
