// Auto-generated. Do not edit!

// (in-package procman_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ProcmanCmd = require('./ProcmanCmd.js');

//-----------------------------------------------------------

class ProcmanCmdStatus {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.cmd = null;
      this.pid = null;
      this.actual_runid = null;
      this.exit_code = null;
      this.cpu_usage = null;
      this.mem_vsize_bytes = null;
      this.mem_rss_bytes = null;
    }
    else {
      if (initObj.hasOwnProperty('cmd')) {
        this.cmd = initObj.cmd
      }
      else {
        this.cmd = new ProcmanCmd();
      }
      if (initObj.hasOwnProperty('pid')) {
        this.pid = initObj.pid
      }
      else {
        this.pid = 0;
      }
      if (initObj.hasOwnProperty('actual_runid')) {
        this.actual_runid = initObj.actual_runid
      }
      else {
        this.actual_runid = 0;
      }
      if (initObj.hasOwnProperty('exit_code')) {
        this.exit_code = initObj.exit_code
      }
      else {
        this.exit_code = 0;
      }
      if (initObj.hasOwnProperty('cpu_usage')) {
        this.cpu_usage = initObj.cpu_usage
      }
      else {
        this.cpu_usage = 0.0;
      }
      if (initObj.hasOwnProperty('mem_vsize_bytes')) {
        this.mem_vsize_bytes = initObj.mem_vsize_bytes
      }
      else {
        this.mem_vsize_bytes = 0;
      }
      if (initObj.hasOwnProperty('mem_rss_bytes')) {
        this.mem_rss_bytes = initObj.mem_rss_bytes
      }
      else {
        this.mem_rss_bytes = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcmanCmdStatus
    // Serialize message field [cmd]
    bufferOffset = ProcmanCmd.serialize(obj.cmd, buffer, bufferOffset);
    // Serialize message field [pid]
    bufferOffset = _serializer.int32(obj.pid, buffer, bufferOffset);
    // Serialize message field [actual_runid]
    bufferOffset = _serializer.int32(obj.actual_runid, buffer, bufferOffset);
    // Serialize message field [exit_code]
    bufferOffset = _serializer.int32(obj.exit_code, buffer, bufferOffset);
    // Serialize message field [cpu_usage]
    bufferOffset = _serializer.float32(obj.cpu_usage, buffer, bufferOffset);
    // Serialize message field [mem_vsize_bytes]
    bufferOffset = _serializer.int64(obj.mem_vsize_bytes, buffer, bufferOffset);
    // Serialize message field [mem_rss_bytes]
    bufferOffset = _serializer.int64(obj.mem_rss_bytes, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcmanCmdStatus
    let len;
    let data = new ProcmanCmdStatus(null);
    // Deserialize message field [cmd]
    data.cmd = ProcmanCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [pid]
    data.pid = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [actual_runid]
    data.actual_runid = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [exit_code]
    data.exit_code = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [cpu_usage]
    data.cpu_usage = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [mem_vsize_bytes]
    data.mem_vsize_bytes = _deserializer.int64(buffer, bufferOffset);
    // Deserialize message field [mem_rss_bytes]
    data.mem_rss_bytes = _deserializer.int64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ProcmanCmd.getMessageSize(object.cmd);
    return length + 32;
  }

  static datatype() {
    // Returns string type for a message object
    return 'procman_ros/ProcmanCmdStatus';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7123dda07ea4fb4e8a54979d8304878d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # describes the state of a command managed by the procman sheriff/deputy
    
    # The command to execute.
    ProcmanCmd cmd
    
    # If the command is running, then this is the pid if not, then this is
    # zero.
    int32 pid
    
    # an ID for the run instance
    int32 actual_runid
    
    # the last exit code
    int32 exit_code
    
    # [0, 1]
    float32 cpu_usage
    
    # total virtual memory used by the process
    int64 mem_vsize_bytes
    
    # total physical memory used by the process
    int64 mem_rss_bytes
    
    
    ================================================================================
    MSG: procman_ros/ProcmanCmd
    # Uniquely identifies the command
    string command_id
    
    # Executable string.
    string exec_str
    
    # Logical group that the command belongs to.
    string group
    
    # If true and the command stops running on its own, then the deputy will
    # automatically restart the command.
    bool auto_respawn
    
    # The POSIX signal number to send when stopping the command. Typically
    # this is something like SIGINT or SIGTERM
    int8 stop_signal
    
    # How much time (seconds) to allow the command to gracefully terminate,
    # when stopping the command, before issuing a SIGKILL.
    float32 stop_time_allowed
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcmanCmdStatus(null);
    if (msg.cmd !== undefined) {
      resolved.cmd = ProcmanCmd.Resolve(msg.cmd)
    }
    else {
      resolved.cmd = new ProcmanCmd()
    }

    if (msg.pid !== undefined) {
      resolved.pid = msg.pid;
    }
    else {
      resolved.pid = 0
    }

    if (msg.actual_runid !== undefined) {
      resolved.actual_runid = msg.actual_runid;
    }
    else {
      resolved.actual_runid = 0
    }

    if (msg.exit_code !== undefined) {
      resolved.exit_code = msg.exit_code;
    }
    else {
      resolved.exit_code = 0
    }

    if (msg.cpu_usage !== undefined) {
      resolved.cpu_usage = msg.cpu_usage;
    }
    else {
      resolved.cpu_usage = 0.0
    }

    if (msg.mem_vsize_bytes !== undefined) {
      resolved.mem_vsize_bytes = msg.mem_vsize_bytes;
    }
    else {
      resolved.mem_vsize_bytes = 0
    }

    if (msg.mem_rss_bytes !== undefined) {
      resolved.mem_rss_bytes = msg.mem_rss_bytes;
    }
    else {
      resolved.mem_rss_bytes = 0
    }

    return resolved;
    }
};

module.exports = ProcmanCmdStatus;
