// Auto-generated. Do not edit!

// (in-package procman_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ProcmanCmdDesired = require('./ProcmanCmdDesired.js');

//-----------------------------------------------------------

class ProcmanOrders {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.deputy_id = null;
      this.sheriff_id = null;
      this.ncmds = null;
      this.cmds = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('deputy_id')) {
        this.deputy_id = initObj.deputy_id
      }
      else {
        this.deputy_id = '';
      }
      if (initObj.hasOwnProperty('sheriff_id')) {
        this.sheriff_id = initObj.sheriff_id
      }
      else {
        this.sheriff_id = '';
      }
      if (initObj.hasOwnProperty('ncmds')) {
        this.ncmds = initObj.ncmds
      }
      else {
        this.ncmds = 0;
      }
      if (initObj.hasOwnProperty('cmds')) {
        this.cmds = initObj.cmds
      }
      else {
        this.cmds = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcmanOrders
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [deputy_id]
    bufferOffset = _serializer.string(obj.deputy_id, buffer, bufferOffset);
    // Serialize message field [sheriff_id]
    bufferOffset = _serializer.string(obj.sheriff_id, buffer, bufferOffset);
    // Serialize message field [ncmds]
    bufferOffset = _serializer.int32(obj.ncmds, buffer, bufferOffset);
    // Serialize message field [cmds]
    // Serialize the length for message field [cmds]
    bufferOffset = _serializer.uint32(obj.cmds.length, buffer, bufferOffset);
    obj.cmds.forEach((val) => {
      bufferOffset = ProcmanCmdDesired.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcmanOrders
    let len;
    let data = new ProcmanOrders(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [deputy_id]
    data.deputy_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [sheriff_id]
    data.sheriff_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [ncmds]
    data.ncmds = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [cmds]
    // Deserialize array length for message field [cmds]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cmds = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cmds[i] = ProcmanCmdDesired.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.deputy_id);
    length += _getByteLength(object.sheriff_id);
    object.cmds.forEach((val) => {
      length += ProcmanCmdDesired.getMessageSize(val);
    });
    return length + 24;
  }

  static datatype() {
    // Returns string type for a message object
    return 'procman_ros/ProcmanOrders';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6540d7c0d68115e54f40b880f9ca7efa';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # message sent by the procman sheriff to provide instructions for a procman
    # deputy.
    
    time timestamp
    string deputy_id
    string sheriff_id
    
    int32 ncmds
    ProcmanCmdDesired[] cmds
    
    
    ================================================================================
    MSG: procman_ros/ProcmanCmdDesired
    # describes the state of a command managed by the procman sheriff/deputy
    # ============ set by the sheriff ==========
    
    # describes the command
    ProcmanCmd cmd
    
    # to start a command running, the sheriff should change desired_runid and
    # unset force_quit
    int32 desired_runid
    
    # flag set by the sheriff.  If set, then the deputy should forcefully
    # terminate the command
    bool force_quit
    
    
    ================================================================================
    MSG: procman_ros/ProcmanCmd
    # Uniquely identifies the command
    string command_id
    
    # Executable string.
    string exec_str
    
    # Logical group that the command belongs to.
    string group
    
    # If true and the command stops running on its own, then the deputy will
    # automatically restart the command.
    bool auto_respawn
    
    # The POSIX signal number to send when stopping the command. Typically
    # this is something like SIGINT or SIGTERM
    int8 stop_signal
    
    # How much time (seconds) to allow the command to gracefully terminate,
    # when stopping the command, before issuing a SIGKILL.
    float32 stop_time_allowed
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcmanOrders(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.deputy_id !== undefined) {
      resolved.deputy_id = msg.deputy_id;
    }
    else {
      resolved.deputy_id = ''
    }

    if (msg.sheriff_id !== undefined) {
      resolved.sheriff_id = msg.sheriff_id;
    }
    else {
      resolved.sheriff_id = ''
    }

    if (msg.ncmds !== undefined) {
      resolved.ncmds = msg.ncmds;
    }
    else {
      resolved.ncmds = 0
    }

    if (msg.cmds !== undefined) {
      resolved.cmds = new Array(msg.cmds.length);
      for (let i = 0; i < resolved.cmds.length; ++i) {
        resolved.cmds[i] = ProcmanCmdDesired.Resolve(msg.cmds[i]);
      }
    }
    else {
      resolved.cmds = []
    }

    return resolved;
    }
};

module.exports = ProcmanOrders;
