// Auto-generated. Do not edit!

// (in-package procman_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ProcmanOutput {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.deputy_id = null;
      this.num_commands = null;
      this.command_ids = null;
      this.text = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('deputy_id')) {
        this.deputy_id = initObj.deputy_id
      }
      else {
        this.deputy_id = '';
      }
      if (initObj.hasOwnProperty('num_commands')) {
        this.num_commands = initObj.num_commands
      }
      else {
        this.num_commands = 0;
      }
      if (initObj.hasOwnProperty('command_ids')) {
        this.command_ids = initObj.command_ids
      }
      else {
        this.command_ids = [];
      }
      if (initObj.hasOwnProperty('text')) {
        this.text = initObj.text
      }
      else {
        this.text = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ProcmanOutput
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [deputy_id]
    bufferOffset = _serializer.string(obj.deputy_id, buffer, bufferOffset);
    // Serialize message field [num_commands]
    bufferOffset = _serializer.int16(obj.num_commands, buffer, bufferOffset);
    // Serialize message field [command_ids]
    bufferOffset = _arraySerializer.string(obj.command_ids, buffer, bufferOffset, null);
    // Serialize message field [text]
    bufferOffset = _arraySerializer.string(obj.text, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ProcmanOutput
    let len;
    let data = new ProcmanOutput(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [deputy_id]
    data.deputy_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [num_commands]
    data.num_commands = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [command_ids]
    data.command_ids = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [text]
    data.text = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.deputy_id);
    object.command_ids.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    object.text.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 22;
  }

  static datatype() {
    // Returns string type for a message object
    return 'procman_ros/ProcmanOutput';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7c6bca4f0a4a3e07776d728216beeab1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Sent by a procman deputy when one or ore child processes write something to
    # stdout/stderr.
    
    # Output from multiple processes can be contained in a single message. This
    # can be done to reduce the number of individual packets transmitted by the
    # deputy.
    
    # Also sent when the deputy itself has something to say.
    
    time timestamp
    
    # Which deputy sent this message.
    string deputy_id
    
    # size of the arrays of commands/text
    int16 num_commands
    
    # Id of each child process.  Empty string if the message is generated by
    # the deputy
    string[] command_ids
    
    string[] text
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ProcmanOutput(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.deputy_id !== undefined) {
      resolved.deputy_id = msg.deputy_id;
    }
    else {
      resolved.deputy_id = ''
    }

    if (msg.num_commands !== undefined) {
      resolved.num_commands = msg.num_commands;
    }
    else {
      resolved.num_commands = 0
    }

    if (msg.command_ids !== undefined) {
      resolved.command_ids = msg.command_ids;
    }
    else {
      resolved.command_ids = []
    }

    if (msg.text !== undefined) {
      resolved.text = msg.text;
    }
    else {
      resolved.text = []
    }

    return resolved;
    }
};

module.exports = ProcmanOutput;
